<template>
  <div class="app-container">
    <el-form ref="queryForm" :model="queryParams" :inline="true" label-width="68px">
      <!-- <el-form-item label="" prop="companyId">
        <el-input
          v-model="queryParams.companyId"
          placeholder="请输入"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <el-form-item label="店铺名称" prop="shopId">
        <el-input
          v-model="queryParams.shopName"
          placeholder="请输入店铺名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <!-- <el-form-item label="店铺id" prop="shopId">
        <el-input
          v-model="queryParams.shopId"
          placeholder="请输入店铺id"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <!-- <el-form-item label="内容" prop="content">
        <el-input
          v-model="queryParams.content"
          placeholder="请输入内容"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
        <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择状态" clearable size="small">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="0：否" prop="deleteFlag">
        <el-input
          v-model="queryParams.deleteFlag"
          placeholder="请输入0：否"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="" prop="gmtCreate">
        <el-date-picker clearable size="small" style="width: 200px"
          v-model="queryParams.gmtCreate"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="" prop="gmtUpdate">
        <el-date-picker clearable size="small" style="width: 200px"
          v-model="queryParams.gmtUpdate"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="" prop="userId">
        <el-input
          v-model="queryParams.userId"
          placeholder="请输入"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="" prop="adminId">
        <el-input
          v-model="queryParams.adminId"
          placeholder="请输入"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item> -->
      <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
      <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-permission="['market:circle:add']"
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-permission="['market:circle:edit']"
          :disabled="single"
          type="success"
          icon="el-icon-edit"
          size="mini"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-permission="['market:circle:remove']"
          :disabled="multiple"
          type="danger"
          icon="el-icon-delete"
          size="mini"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-permission="['market:circle:export']"
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
        >导出</el-button>
      </el-col>
    </el-row>

    <el-table v-loading="loading" :data="circleList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="" align="center" prop="id" /> -->
      <!-- <el-table-column label="" align="center" prop="companyId" /> -->
      <!-- <el-table-column label="店铺id" align="center" prop="shopId" /> -->
      <el-table-column label="店铺名称" align="center" prop="shopName" />
      <el-table-column label="内容" align="center" prop="content" />
      <!-- <el-table-column label="状态" align="center" prop="status" /> -->
      <!-- <el-table-column label="附件" align="center" prop="url" /> -->
      <el-table-column label="附件" align="center" prop="url" width="180">
        <template slot-scope="scope">
          <img v-for="(item,index) in scope.row.url" :src="item" :key="index" alt="" width="40">
        </template>
      </el-table-column>
      <!-- <el-table-column label="0：否" align="center" prop="deleteFlag" /> -->
      <!-- <el-table-column label="" align="center" prop="gmtCreate" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.gmtCreate) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="" align="center" prop="gmtUpdate" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.gmtUpdate) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="" align="center" prop="userId" />
      <el-table-column label="" align="center" prop="adminId" /> -->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            v-permission="['market:circle:edit']"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            v-permission="['market:circle:remove']"
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.page"
      :limit.sync="queryParams.limit"
      @pagination="getList"
    />

    <!-- 添加或修改生鲜圈对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <!-- <el-form-item label="" prop="companyId">
          <el-input v-model="form.companyId" placeholder="请输入" />
        </el-form-item> -->
        <!-- <el-form-item label="店铺id" prop="shopId">
          <el-input v-model="form.shopId" placeholder="请输入店铺id" />
        </el-form-item> -->
        <el-form-item label="类型">
          shopId{{ form.shopId }}
          <el-select
            v-model="form.shopId"
            filterable
            placeholder="请选择店铺名称">
            <el-option
              v-for="(item, index) in shopList"
              :key="index"
              :label="item.name"
              :value="item.id"/>
          </el-select>
        </el-form-item>
        <el-form-item label="内容" prop="content">
          <el-input v-model="form.content" placeholder="请输入内容" type="textarea"/>
        </el-form-item>
        <!-- <el-form-item label="状态">
          <el-radio-group v-model="form.status">
            <el-radio label="1">请选择字典生成</el-radio>
          </el-radio-group>
        </el-form-item> -->
        <el-form-item label="附件" prop="url">
          <!-- <el-input v-model="form.url" type="textarea" placeholder="请输入内容" /> -->
          <el-upload
            :limit="9"
            :http-request="function(file){return uploadSectionFile(file)}"
            :file-list="form.imgList"
            :on-remove="handleRemove"
            style="width:150px"
            action="#"
            list-type="picture-card">
            <i class="el-icon-plus" />
          </el-upload>
        </el-form-item>
        <!-- <el-form-item label="0：否" prop="deleteFlag">
          <el-input v-model="form.deleteFlag" placeholder="请输入0：否" />
        </el-form-item> -->
        <!-- <el-form-item label="" prop="gmtCreate">
          <el-date-picker
            v-model="form.gmtCreate"
            clearable
            size="small"
            style="width: 200px"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择"/>
        </el-form-item> -->
        <!-- <el-form-item label="" prop="gmtUpdate">
          <el-date-picker
            v-model="form.gmtUpdate"
            clearable
            size="small"
            style="width: 200px"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择"/>
        </el-form-item> -->
        <!-- <el-form-item label="" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入" />
        </el-form-item> -->
        <!-- <el-form-item label="" prop="adminId">
          <el-input v-model="form.adminId" placeholder="请输入" />
        </el-form-item> -->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listCircle, getCircle, delCircle, addCircle, updateCircle, exportCircle } from '@/api/market/circle'
import { listShopInfo, getShopInfo, delShopInfo, addShopInfo, updateShopInfo, exportShopInfo } from '@/api/market/shopInfo'
import { createStorage } from '@/api/storage'
export default {
  data() {
    return {
      shopList: [],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 生鲜圈表格数据
      circleList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        page: 1,
        limit: 10,
        companyId: undefined,
        shopId: undefined,
        content: undefined,
        status: undefined,
        url: undefined,
        deleteFlag: undefined,
        gmtCreate: undefined,
        gmtUpdate: undefined,
        userId: undefined,
        adminId: undefined
      },
      // 表单参数
      form: {
      },
      // 表单校验
      rules: {
        deleteFlag: [
          { required: true, message: '0：否（默认） 1：是不能为空', trigger: 'blur' }
        ] }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    uploadSectionFile(params) {
      // FormData 对象
      const file = params.file
      const typeArr = ['image/png', 'image/gif', 'image/jpeg', 'image/jpg']
      const isJPG = typeArr.indexOf(file.type) !== -1
      const isLt3M = file.size / 1024 / 1024 < 5
      if (!isJPG) {
        this.$message.error('请上传图片格式!')
        return
      }
      if (!isLt3M) {
        this.$message.error('上传图片大小不能超过 5MB!')
        return
      }
      var formData = new FormData()
      formData.append('file', file)
      // formData.append('code',imgCode)
      createStorage(formData).then(res => { debugger
        console.log(this.form)
        if (res.status == '200') {
          this.form.url.push(res.data.url)
        }
      })
    },
    /** 查询生鲜圈列表 */
    getList() {
      this.loading = true
      listShopInfo({
        page: 1,
        limit: 1000
      }).then(response => {
        this.shopList = response.data.data.items
        this.loading = false
      })
      listCircle(this.queryParams).then(response => {
        this.circleList = response.data.data.items
        this.total = response.data.data.count
        this.loading = false
        for (let i = 0; i<this.circleList.length; i++) {
          this.circleList[i].url =this.circleList[i].url.split(',')
        }
      })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        companyId: undefined,
        shopId: undefined,
        content: undefined,
        status: '0',
        url: [],
        deleteFlag: undefined,
        gmtCreate: undefined,
        gmtUpdate: undefined,
        userId: undefined,
        adminId: undefined
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.page = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!=1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加生鲜圈'
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const id = row.id || this.ids.join(',')
      getCircle(id).then(response => {
        this.form = response.data.data
        this.form.imgList = []
        const _imgList = response.data.data.url.split(',')
        this.form.url = response.data.data.url.split(',')
        for (let i = 0; i<_imgList.length; i++) {
          this.form.imgList.push({
            url: _imgList[i]
          })
        }
        console.log(this.form)
        this.open = true
        this.title = '修改生鲜圈'
      })
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs['form'].validate(valid => {
        this.form.url = this.form.url.toString()
        delete this.form.imgList
        console.log(this.from)
        if (valid) {
          if (this.form.id != undefined) {
            updateCircle(this.form).then(response => {
              if (response.data) {
                this.msgSuccess('修改成功')
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          } else {
            addCircle(this.form).then(response => {
              if (response.data) {
                this.msgSuccess('新增成功')
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids.join(',')
      this.$confirm('是否确认删除生鲜圈编号为"' + ids + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return delCircle(ids)
      }).then(() => {
        this.getList()
        this.msgSuccess('删除成功')
      }).catch(function() {})
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams
      this.$confirm('是否确认导出所有生鲜圈数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return exportCircle(queryParams)
      }).then(response => {
        this.download(response.data.data)
      }).catch(function() {})
    },
    handleRemove: function (file, fileList) { debugger
      for (var i = 0; i < this.form.url.length; i++) {
        // 这里存在两种情况
        // 1. 如果所删除图片是刚刚上传的图片，那么图片地址是file.response.url
        //    此时的file.url虽然存在，但是是本机地址，而不是远程地址。
        // 2. 如果所删除图片是后台返回的已有图片，那么图片地址是file.url
        var url
        if (file.response === undefined) {
          url = file.url
        } else {
          url = file.response.url
        }

        if (this.form.url[i] === url) {
          this.form.url.splice(i, 1)
        }
      }
      // if (this.form.imgList.length > 0) {
      //   this.form.pictureUrl = this.form.imgList[0]
      // }
    }

  }
}
</script>
